diff --git a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
similarity index 61%
rename from src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
rename to src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index 058fb00ab..95445e365 100644
--- a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -2,30 +2,31 @@ package net.minecraft.server.entity.player;
 
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.PortalBlock;
 import net.minecraft.core.block.entity.*;
-import net.minecraft.core.crafting.ICrafting;
+import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityArrow;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemComplex;
+import net.minecraft.core.item.IComplexItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.menu.*;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.server.entity.EntityTracker;
-import net.minecraft.server.net.handler.NetServerHandler;
+import net.minecraft.server.net.handler.ServerPacketHandler;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.server.world.ServerPlayerController;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.player.inventory.*;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.phys.AABB;
@@ -42,22 +43,8 @@ import java.util.LinkedList;
 import java.util.List;
 import java.util.Set;
 
-// Referenced classes of package net.minecraft.src:
-//            EntityPlayer, ICrafting, ItemStack, ItemInWorldManager, 
-//            World, ChunkCoordinates, WorldProvider, WorldServer, 
-//            Container, Packet5PlayerInventory, EntityTracker, InventoryPlayer, 
-//            EntityArrow, Item, NetServerHandler, ItemMapBase, 
-//            ChunkCoordIntPair, Packet51MapChunk, TileEntity, PropertyManager, 
-//            ServerConfigurationManager, Packet8UpdateHealth, Entity, EntityItem, 
-//            Packet22Collect, Packet18Animation, EnumStatus, Packet17Sleep, 
-//            Packet39AttachEntity, Packet100OpenWindow, ContainerWorkbench, IInventory, 
-//            ContainerChest, TileEntityFurnace, ContainerFurnace, TileEntityDispenser, 
-//            ContainerDispenser, SlotCrafting, Packet103SetSlot, Packet104WindowItems, 
-//            Packet105UpdateProgressbar, Packet101CloseWindow, StatBase, Packet200Statistic, 
-//            StringTranslate, Packet3Chat
-
-public class EntityPlayerMP extends EntityPlayer implements ICrafting {
-    public EntityPlayerMP(MinecraftServer minecraftserver, World world, String s, ServerPlayerController iteminworldmanager)
+public class ServerPlayer extends Player implements ContainerListener {
+    public ServerPlayer(MinecraftServer minecraftserver, World world, String s, ServerPlayerController iteminworldmanager)
     {
         super(world);
         loadedChunks = new LinkedList();
@@ -105,16 +92,16 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     @Override
 	public void setGamemode(Gamemode gamemode)
     {
-        mcServer.playerList.sendPacketToAllPlayers(new Packet41EntityPlayerGamemode(this.id, gamemode.getId()));
+        mcServer.playerList.sendPacketToAllPlayers(new PlayerGamemodePacket(this.id, gamemode.getId()));
         this.gamemode = gamemode;
 
-        ContainerPlayer newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
+        InventoryMenu newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
         if (craftingInventory == inventorySlots)
         {
             craftingInventory = newContainer;
         }
         inventorySlots = newContainer;
-        inventorySlots.onContainerInit(this);
+        inventorySlots.addSlotListener(this);
         if (!gamemode.canPlayerFly())
         {
             noPhysics = false;
@@ -140,7 +127,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 	public void awardKillScore(Entity entity, int i)
     {
         super.awardKillScore(entity, i);
-        mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(username, nickname, score, chatColor, true, isOperator()));
+        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(username, nickname, score, chatColor, true, isOperator()));
     }
 
     public boolean isOperator()
@@ -177,7 +164,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 
     public void func_20057_k()
     {
-        craftingInventory.onContainerInit(this);
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
@@ -203,13 +190,13 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     {
         playerController.tick();
         ticksOfInvuln--;
-        craftingInventory.updateInventory();
+        craftingInventory.broadcastChanges();
         for (int i = 0; i < 5; i++)
         {
             ItemStack itemstack = getEquipmentInSlot(i);
             if (itemstack != playerInventory[i])
             {
-                mcServer.getEntityTracker(dimension).sendPacketToTrackedPlayers(this, new Packet5PlayerInventory(id, i, itemstack));
+                mcServer.getEntityTracker(dimension).sendPacketToTrackedPlayers(this, new SetEquippedItemPacket(id, i, itemstack));
                 playerInventory[i] = itemstack;
             }
         }
@@ -224,10 +211,10 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
             name = username;
         }
         else {
-            List<EntityPlayer> players = new ArrayList<>(MinecraftServer.getInstance().playerList.playerEntities);
-            players.sort(new EntityPlayer.SortByUsername());
+            List<Player> players = new ArrayList<>(MinecraftServer.getInstance().playerList.playerEntities);
+            players.sort(new Player.SortByUsername());
             int nickNum = 0;
-            for (EntityPlayer player : players){
+            for (Player player : players){
                 if (player == this) break;
                 if (player.nickname.equals(this.nickname)){
                     nickNum++;
@@ -263,14 +250,14 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         }
         if (!mcServer.pvpOn)
         {
-            if (attacker instanceof EntityPlayer)
+            if (attacker instanceof Player)
             {
                 return false;
             }
-            if (attacker instanceof EntityArrow)
+            if (attacker instanceof ArrowProjectile)
             {
-                EntityArrow entityarrow = (EntityArrow) attacker;
-                if (entityarrow.owner instanceof EntityPlayer)
+                ArrowProjectile entityarrow = (ArrowProjectile) attacker;
+                if (entityarrow.owner instanceof Player)
                 {
                     return false;
                 }
@@ -295,14 +282,14 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     {
         super.tick();
 
-        for (int i = 0; i < inventory.getSizeInventory(); i++)
+        for (int i = 0; i < inventory.getContainerSize(); i++)
         {
-            ItemStack itemstack = inventory.getStackInSlot(i);
-            if (itemstack == null || !Item.itemsList[itemstack.itemID].isComplex() || playerNetServerHandler.getNumChunkDataPackets() > 2)
+            ItemStack itemstack = inventory.getItem(i);
+            if (itemstack == null || !(Item.itemsList[itemstack.itemID] instanceof IComplexItem) || playerNetServerHandler.getNumChunkDataPackets() > 2)
             {
                 continue;
             }
-            Packet packet = ((ItemComplex) Item.itemsList[itemstack.itemID]).sendPacketData(itemstack, world, this);
+            Packet packet = ((IComplexItem) Item.itemsList[itemstack.itemID]).sendPacketData(itemstack, world, this);
             if (packet != null)
             {
                 playerNetServerHandler.sendPacket(packet);
@@ -311,7 +298,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 
         if (inPortal)
         {
-            int targetDim = ((BlockPortal) Block.blocksList[portalID]).targetDimension;
+            int targetDim = ((PortalBlock) Block.blocksList[portalID]).targetDimension;
             boolean netherAllowed = mcServer.propertyManager.getBooleanProperty("allow-nether", true);
             boolean paradiseAllowed = mcServer.propertyManager.getBooleanProperty("allow-paradise", false);
             if ((netherAllowed && targetDim == Dimension.nether.id) || (paradiseAllowed && targetDim == Dimension.paradise.id) || (targetDim != Dimension.nether.id && targetDim != Dimension.paradise.id))
@@ -361,12 +348,12 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         }
         if (getHealth() != lastHealth)
         {
-            playerNetServerHandler.sendPacket(new Packet8UpdateHealth(getHealth()));
+            playerNetServerHandler.sendPacket(new SetHealthPacket(getHealth()));
             lastHealth = getHealth();
         }
         if (score != lastScore)
         {
-            playerNetServerHandler.sendPacket(new Packet72UpdatePlayerProfile(username, nickname, score, chatColor, true, isOperator()));
+            playerNetServerHandler.sendPacket(new UpdatePlayerProfilePacket(username, nickname, score, chatColor, true, isOperator()));
             lastScore = score;
         }
     }
@@ -382,18 +369,18 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
                 {
                     WorldServer worldserver = mcServer.getDimensionWorld(dimension);
                     loadedChunks.remove(chunkCoord);
-                    playerNetServerHandler.sendPacket(new Packet51MapChunk(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, worldserver));
+                    playerNetServerHandler.sendPacket(new BlockRegionUpdatePacket(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, worldserver));
                     List list = worldserver.getTileEntityList(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, chunkCoord.x * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, chunkCoord.z * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z);
                     for (int j = 0; j < list.size(); j++)
                     {
-                        getTileEntityInfo((TileEntity) list.get(j));
+                        getTileEntityInfo((BlockEntity) list.get(j));
                     }
                 }
             }
         }
     }
 
-    private void getTileEntityInfo(TileEntity tileentity)
+    private void getTileEntityInfo(BlockEntity tileentity)
     {
         if (tileentity != null)
         {
@@ -416,22 +403,22 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     }
 
     @Override
-	public void onItemPickup(Entity entity, int i)
+	public void onItemPickup(Entity entity, ItemStack item)
     {
         if (!entity.removed)
         {
             EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
-            if (entity instanceof EntityItem)
+            if (entity instanceof ItemEntity)
             {
-                entitytracker.sendPacketToTrackedPlayers(entity, new Packet22Collect(entity.id, id));
+                entitytracker.sendPacketToTrackedPlayers(entity, new TakeItemEntityPacket(entity.id, id));
             }
-            if (entity instanceof EntityArrow)
+            if (entity instanceof ArrowProjectile)
             {
-                entitytracker.sendPacketToTrackedPlayers(entity, new Packet22Collect(entity.id, id));
+                entitytracker.sendPacketToTrackedPlayers(entity, new TakeItemEntityPacket(entity.id, id));
             }
         }
-        super.onItemPickup(entity, i);
-        craftingInventory.updateInventory();
+        super.onItemPickup(entity, item);
+        craftingInventory.broadcastChanges();
     }
 
     @Override
@@ -442,7 +429,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
             swingProgressInt = -1;
             isSwinging = true;
             EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
-            entitytracker.sendPacketToTrackedPlayers(this, new Packet18Animation(this, 1));
+            entitytracker.sendPacketToTrackedPlayers(this, new AnimatePacket(this, 1));
         }
     }
 
@@ -457,10 +444,10 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         if (enumstatus == EnumSleepStatus.OK)
         {
             EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
-            Packet17Sleep packet17sleep = new Packet17Sleep(this, 0, i, j, k);
-            entitytracker.sendPacketToTrackedPlayers(this, packet17sleep);
+            SleepPacket sleepPacket = new SleepPacket(this, 0, i, j, k);
+            entitytracker.sendPacketToTrackedPlayers(this, sleepPacket);
             playerNetServerHandler.teleportAndRotate(x, y, z, yRot, xRot);
-            playerNetServerHandler.sendPacket(packet17sleep);
+            playerNetServerHandler.sendPacket(sleepPacket);
         }
         return enumstatus;
     }
@@ -471,7 +458,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         if (isPlayerSleeping())
         {
             EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
-            entitytracker.sendPacketToTrackedPlayersAndTrackedEntity(this, new Packet18Animation(this, 3));
+            entitytracker.sendPacketToTrackedPlayersAndTrackedEntity(this, new AnimatePacket(this, 3));
             super.wakeUpPlayer(flag, flag1);
         }
         if (playerNetServerHandler != null)
@@ -491,10 +478,10 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         }
         super.startRiding(vehicle);
         if (vehicle instanceof Entity) {
-            playerNetServerHandler.sendPacket(new Packet39AttachEntity(this, (Entity) this.vehicle));
-        } else if (vehicle instanceof TileEntity) {
-            TileEntity tileEntity = (TileEntity) vehicle;
-            playerNetServerHandler.sendPacket(new Packet39AttachEntity(this, tileEntity.x, tileEntity.y, tileEntity.z));
+            playerNetServerHandler.sendPacket(new SetRidingPacket(this, (Entity) this.vehicle));
+        } else if (vehicle instanceof BlockEntity) {
+            BlockEntity blockEntity = (BlockEntity) vehicle;
+            playerNetServerHandler.sendPacket(new SetRidingPacket(this, blockEntity.x, blockEntity.y, blockEntity.z));
         }
         playerNetServerHandler.teleport(x, y, z);
     }
@@ -518,90 +505,90 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 	public void displayGUIWorkbench(int i, int j, int k)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 1, "Crafting", 9));
-        craftingInventory = new ContainerWorkbench(inventory, world, i, j, k);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 1, "Crafting", 9));
+        craftingInventory = new CraftingMenu(inventory, world, i, j, k);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
     public void displayGUIPaintingPicker()
     {
-        playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 7, "Painting", 0));
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 7, "Painting", 0));
     }
 
     @Override
-	public void displayGUIChest(IInventory iinventory)
+	public void displayGUIChest(Container iinventory)
     {
         getNextWindowId();
-        NetServerHandler.logger.info((new StringBuilder()).append(username).append(" interacted with chest at (").append(x).append(", ").append(y).append(", ").append(z).append(")").toString());
-        playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 0, iinventory.getInvName(), iinventory.getSizeInventory()));
-        craftingInventory = new ContainerChest(inventory, iinventory);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        ServerPacketHandler.logger.info((new StringBuilder()).append(username).append(" interacted with chest at (").append(x).append(", ").append(y).append(", ").append(z).append(")").toString());
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 0, iinventory.getName(), iinventory.getContainerSize()));
+        craftingInventory = new ContainerMenu(inventory, iinventory);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
-	public void displayGUIFurnace(TileEntityFurnace tileentityfurnace)
+	public void displayGUIFurnace(FurnaceBlockEntity tileentityfurnace)
     {
         getNextWindowId();
-        if (tileentityfurnace instanceof TileEntityBlastFurnace)
+        if (tileentityfurnace instanceof BlastFurnaceBlockEntity)
         {
-            playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 4, tileentityfurnace.getInvName(), tileentityfurnace.getSizeInventory()));
+            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 4, tileentityfurnace.getName(), tileentityfurnace.getContainerSize()));
         }
         else
         {
-            playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 2, tileentityfurnace.getInvName(), tileentityfurnace.getSizeInventory()));
+            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 2, tileentityfurnace.getName(), tileentityfurnace.getContainerSize()));
         }
 
-        craftingInventory = new ContainerFurnace(inventory, tileentityfurnace);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        craftingInventory = new FurnaceMenu(inventory, tileentityfurnace);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
-	public void displayGUIDispenser(TileEntityDispenser tileentitydispenser)
+	public void displayGUIDispenser(DispenserBlockEntity tileentitydispenser)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 3, tileentitydispenser.getInvName(), tileentitydispenser.getSizeInventory()));
-        craftingInventory = new ContainerDispenser(inventory, tileentitydispenser);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 3, tileentitydispenser.getName(), tileentitydispenser.getContainerSize()));
+        craftingInventory = new TrapMenu(inventory, tileentitydispenser);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
-	public void displayGUITrommel(TileEntityTrommel tileentitytrommel)
+	public void displayGUITrommel(TrommelBlockEntity tileentitytrommel)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new Packet100OpenWindow(currentWindowId, 5, tileentitytrommel.getInvName(), tileentitytrommel.getSizeInventory()));
-        craftingInventory = new ContainerTrommel(inventory, tileentitytrommel);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 5, tileentitytrommel.getName(), tileentitytrommel.getContainerSize()));
+        craftingInventory = new TrommelMenu(inventory, tileentitytrommel);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
-    public void displayGUIEditFlag(TileEntityFlag tileEntityFlag)
+    public void displayGUIEditFlag(FlagBlockEntity tileEntityFlag)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new Packet142OpenFlagWindow(currentWindowId, tileEntityFlag.x, tileEntityFlag.y, tileEntityFlag.z));
-        craftingInventory = new ContainerFlag(inventory, tileEntityFlag);
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        playerNetServerHandler.sendPacket(new FlagOpenPacket(currentWindowId, tileEntityFlag.x, tileEntityFlag.y, tileEntityFlag.z));
+        craftingInventory = new FlagMenu(inventory, tileEntityFlag);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     public void displayGUIGuidebook()
     {
         getNextWindowId();
 
-        craftingInventory = new ContainerGuidebook();
-        craftingInventory.windowId = currentWindowId;
-        craftingInventory.onContainerInit(this);
+        craftingInventory = new GuidebookMenu();
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
     }
 
     @Override
-	public void updateInventorySlot(Container container, int i, ItemStack itemstack)
+	public void updateInventorySlot(AbstractContainerMenu container, int i, ItemStack itemstack)
     {
-        if (container.getSlot(i) instanceof SlotCrafting)
+        if (container.getSlot(i) instanceof ResultSlot)
         {
             return;
         }
@@ -613,33 +600,33 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         {
             if (playerNetServerHandler != null)
             {
-                playerNetServerHandler.sendPacket(new Packet103SetSlot(container.windowId, i, itemstack));
+                playerNetServerHandler.sendPacket(new ContainerSetSlotPacket(container.containerId, i, itemstack));
             }
             return;
         }
     }
 
-    public void func_28017_a(Container container)
+    public void func_28017_a(AbstractContainerMenu container)
     {
         updateCraftingInventory(container, container.func_28127_b());
     }
 
     @Override
-	public void updateCraftingInventory(Container container, List<ItemStack> list)
+	public void updateCraftingInventory(AbstractContainerMenu container, List<ItemStack> list)
     {
 
         //playernetserverhandler returning false?
         if (playerNetServerHandler != null)
         {
-            playerNetServerHandler.sendPacket(new Packet104WindowItems(container.windowId, list));
-//            playerNetServerHandler.sendPacket(new Packet103SetSlot(-1, -1, inventory.getHeldItemStack()));
+            playerNetServerHandler.sendPacket(new ContainerSetContentPacket(container.containerId, list));
+//            playerNetServerHandler.sendPacket(new ContainerSetSlotPacket(-1, -1, inventory.getHeldItemStack()));
         }
     }
 
     @Override
-	public void updateCraftingInventoryInfo(Container container, int id, int value)
+	public void updateCraftingInventoryInfo(AbstractContainerMenu container, int id, int value)
     {
-        playerNetServerHandler.sendPacket(new Packet105UpdateProgressbar(container.windowId, id, value));
+        playerNetServerHandler.sendPacket(new ContainerSetDataPacket(container.containerId, id, value));
     }
 
     @Override
@@ -649,7 +636,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 
     public void usePersonalCraftingInventory()
     {
-        playerNetServerHandler.sendPacket(new Packet101CloseWindow(craftingInventory.windowId));
+        playerNetServerHandler.sendPacket(new ContainerClosePacket(craftingInventory.containerId));
         closeCraftingGui();
     }
 
@@ -661,7 +648,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
         }
         else
         {
-            playerNetServerHandler.sendPacket(new Packet103SetSlot(-1, -1, inventory.getHeldItemStack()));
+            playerNetServerHandler.sendPacket(new ContainerSetSlotPacket(-1, -1, inventory.getHeldItemStack()));
             return;
         }
     }
@@ -683,20 +670,21 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     }
 
     @Override
-	public void addStat(Stat statbase, int i)
+	public void addStat(Stat stat, int i)
     {
-        if (statbase == null)
+        if (stat == null)
         {
             return;
         }
-        if (!statbase.clientside)
+        if (!stat.clientside)
         {
-            for (; i > 100; i -= 100)
-            {
-                playerNetServerHandler.sendPacket(new Packet200Statistic(statbase.statId, 100));
+            for (; i > 100; i -= 100) { // send value change in groups of 100
+                playerNetServerHandler.sendPacket(new StatisticPacket(stat.statId, 100));
             }
 
-            playerNetServerHandler.sendPacket(new Packet200Statistic(statbase.statId, i));
+            if (i > 0) {
+                playerNetServerHandler.sendPacket(new StatisticPacket(stat.statId, i));
+            }
         }
     }
     public void func_30002_A()
@@ -717,34 +705,34 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
 
     public void func_30001_B()
     {
-        lastHealth = 0xfa0a1f01;
-        lastScore = 0xfa0a1f01;
+        lastHealth = Integer.MIN_VALUE;
+        lastScore = Integer.MIN_VALUE;
     }
 
     public void func_22061_a(String s)
     {
         I18n stringtranslate = I18n.getInstance();
         String s1 = stringtranslate.translateKey(s);
-        playerNetServerHandler.sendPacket(new Packet3Chat(s1));
+        playerNetServerHandler.sendPacket(new ChatPacket(s1));
     }
     
     @Override
     public void setCurrentItem(int i) {
     	super.setCurrentItem(i);
-    	playerNetServerHandler.sendPacket(new Packet16BlockItemSwitch(i));
+    	playerNetServerHandler.sendPacket(new SetCarriedItemPacket(i));
     }
 
 	@Override
 	public void sendMessage(String message) {
-		playerNetServerHandler.sendPacket(new Packet3Chat(message, 0, AES.keyChain.get(username)));
+		playerNetServerHandler.sendPacket(new ChatPacket(message, 0, AES.keyChain.get(username)));
 	}
 
 	@Override
 	public void sendStatusMessage(String message) {
-		playerNetServerHandler.sendPacket(new Packet3Chat(message, 1, AES.keyChain.get(username)));
+		playerNetServerHandler.sendPacket(new ChatPacket(message, 1, AES.keyChain.get(username)));
 	}
 
-    public NetServerHandler playerNetServerHandler;
+    public ServerPacketHandler playerNetServerHandler;
     public MinecraftServer mcServer;
     public ServerPlayerController playerController;
     public double field_9155_d;
diff --git a/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java b/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
index b7f125391..e3d78a8dc 100644
--- a/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
+++ b/src/main/java/net/minecraft/server/gui/GuiStatsComponent.java
@@ -29,7 +29,7 @@ public class GuiStatsComponent extends JComponent
         long l = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
         System.gc();
         displayStrings[0] = (new StringBuilder()).append("Memory use: ").append(l / 1024L / 1024L).append(" mb (").append((Runtime.getRuntime().freeMemory() * 100L) / Runtime.getRuntime().maxMemory()).append("% free)").toString();
-        displayStrings[1] = (new StringBuilder()).append("Threads: ").append(NetworkManager.numReadThreads).append(" + ").append(NetworkManager.numWriteThreads).toString();
+        displayStrings[1] = (new StringBuilder()).append("Threads: ").append(NetworkManager.readThreads).append(" + ").append(NetworkManager.writeThreads).toString();
         memoryUse[updateCounter++ & 0xff] = (int)((l * 100L) / Runtime.getRuntime().maxMemory());
         repaint();
     }
